from typing import Dict, Optional

from seleniumwire import webdriver

class SgChromeDriver:

    def __init__(self):
        """
        Chrome Web Driver backed by the selenium-wire library
        """

        chrome_options = webdriver.ChromeOptions()
        chrome_options.add_argument("--no-sandbox")
        chrome_options.add_argument("--headless")
        chrome_options.add_argument("--disable-gpu")

        driver = webdriver.Chrome(chrome_options=chrome_options)
        self.__driver = driver

    def get_driver(self):
        """
        For unfettered access to the base driver
        :return:
        """
        return self.__driver

    def get_default_headers_for(self, request_url: str) -> Dict[str, str]:
        self.__driver.get(request_url)

        for req in self.__driver.requests:
            if req.method == 'GET':
                return req.headers